Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynadv_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynadv_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynadv_tam.F90	(revision 2587)
@@ -547,5 +547,5 @@
       END IF
    END SUBROUTINE dyn_adv_ctl_tam
-
+#if defined key_tst_tlm
    SUBROUTINE dyn_adv_tlm_tst( kumadt )
       !!-----------------------------------------------------------------------
@@ -580,4 +580,5 @@
       USE tamtrj              ! writing out state trajectory
       USE par_tlm,    ONLY: &
+        & tlm_bch,          &
         & cur_loop,         &
         & h_ratio
@@ -641,5 +642,5 @@
 
       CHARACTER(LEN=14)   :: cl_name
-      CHARACTER (LEN=128) :: file_out, file_wop
+      CHARACTER (LEN=128) :: file_out, file_wop, file_xdx
       CHARACTER (LEN=90)  ::  FMT
       REAL(KIND=wp), DIMENSION(100):: &
@@ -696,9 +697,8 @@
       ! Output filename Xn=F(X0)
       !--------------------------------------------------------------------
-      file_wop='trj_wop_dynadv'
-
       CALL tlm_namrd
       gamma = h_ratio
-
+      file_wop='trj_wop_dynadv'
+      file_xdx='trj_xdx_dynadv'
       !--------------------------------------------------------------------
       ! Initialize the tangent input with random noise: dx
@@ -741,5 +741,5 @@
       ! Complete Init for Direct
       !-------------------------------------------------------------------
-      CALL istate_p  
+      IF ( tlm_bch /= 2 )      CALL istate_p  
 
       ! *** initialize the reference trajectory
@@ -769,16 +769,11 @@
       !  Compute the direct model F(X0,t=n) = Xn
       !--------------------------------------------------------------------
-      CALL dyn_adv(nit000)
-      IF ( cur_loop .EQ. 0) CALL trj_wri_spl(file_wop)
+      IF ( tlm_bch /= 2 ) CALL dyn_adv(nit000)
+      IF ( tlm_bch == 0 ) CALL trj_wri_spl(file_wop)
+      IF ( tlm_bch == 1 ) CALL trj_wri_spl(file_xdx)
       !--------------------------------------------------------------------
       !  Compute the Tangent 
       !--------------------------------------------------------------------
-      IF ( cur_loop .NE. 0) THEN
-         !--------------------------------------------------------------------
-         !  Storing data
-         !--------------------------------------------------------------------  
-         zua_out  (:,:,:) = ua   (:,:,:)
-         zva_out  (:,:,:) = va   (:,:,:)          
-
+      IF ( tlm_bch == 2 ) THEN        
          !--------------------------------------------------------------------
          ! Initialize the tangent variables 
@@ -812,4 +807,7 @@
          zua_wop  (:,:,:) = ua  (:,:,:)
          zva_wop  (:,:,:) = va  (:,:,:)
+         CALL trj_rd_spl(file_xdx) 
+         zua_out  (:,:,:) = ua  (:,:,:)
+         zva_out  (:,:,:) = va  (:,:,:)
          !--------------------------------------------------------------------
          ! Compute the Linearization Error 
@@ -944,3 +942,4 @@
    END SUBROUTINE dyn_adv_tlm_tst
 #endif
+#endif
 END MODULE dynadv_tam
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynhpg_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynhpg_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynhpg_tam.F90	(revision 2587)
@@ -109,5 +109,7 @@
    PUBLIC   dyn_hpg_adj    ! routine called by step_tam module
    PUBLIC   dyn_hpg_adj_tst! routine called by test module
+#if defined key_tst_tlm
    PUBLIC   dyn_hpg_tlm_tst! routine called by test module
+#endif
 
    !!* Namelist nam_dynhpg : Choice of horizontal pressure gradient computation
@@ -1059,5 +1061,5 @@
          &              )
    END SUBROUTINE dyn_hpg_adj_tst
-
+#if defined key_tst_tlm
    SUBROUTINE dyn_hpg_tlm_tst( kumadt )
       !!-----------------------------------------------------------------------
@@ -1089,4 +1091,5 @@
       USE tamtrj              ! writing out state trajectory
       USE par_tlm,    ONLY: &
+        & tlm_bch,          &
         & cur_loop,         &
         & h_ratio
@@ -1160,5 +1163,5 @@
          & jk
       CHARACTER(LEN=14)   :: cl_name
-      CHARACTER (LEN=128) :: file_out, file_wop
+      CHARACTER (LEN=128) :: file_out, file_wop, file_xdx
       CHARACTER (LEN=90)  ::  FMT
       REAL(KIND=wp), DIMENSION(100):: &
@@ -1228,9 +1231,8 @@
       ! Output filename Xn=F(X0)
       !--------------------------------------------------------------------
-      file_wop='trj_wop_dynhpg'
-
       CALL tlm_namrd
       gamma = h_ratio  
-
+      file_wop='trj_wop_dynhpg'
+      file_xdx='trj_xdx_dynhpg'
        !--------------------------------------------------------------------
       ! Initialize the tangent input with random noise: dx
@@ -1262,5 +1264,5 @@
       ! Complete Init for Direct
       !-------------------------------------------------------------------
-      CALL istate_p  
+      IF ( tlm_bch /= 2 )      CALL istate_p  
 
       ! *** initialize the reference trajectory
@@ -1296,16 +1298,11 @@
       !  Compute the direct model F(X0,t=n) = Xn
       !--------------------------------------------------------------------
-      CALL dyn_hpg(nit000)
-      IF ( cur_loop .EQ. 0) CALL trj_wri_spl(file_wop)
+      IF ( tlm_bch /= 2 ) CALL dyn_hpg(nit000)
+      IF ( tlm_bch == 0 ) CALL trj_wri_spl(file_wop)
+      IF ( tlm_bch == 1 ) CALL trj_wri_spl(file_xdx)
       !--------------------------------------------------------------------
       !  Compute the Tangent 
       !--------------------------------------------------------------------
-      IF ( cur_loop .NE. 0) THEN
-         !--------------------------------------------------------------------
-         !  Storing data
-         !--------------------------------------------------------------------  
-         zua_out  (:,:,:) = ua   (:,:,:)
-         zva_out  (:,:,:) = va   (:,:,:)          
-
+      IF ( tlm_bch == 2 ) THEN
          !--------------------------------------------------------------------
          ! Initialize the tangent variables 
@@ -1324,5 +1321,4 @@
          ! Compute the scalar product: ( L(t0,tn) gamma dx0 ) )
          !--------------------------------------------------------------------
-
          zsp2_1    = DOT_PRODUCT( ua_tl, ua_tl  )
          zsp2_2    = DOT_PRODUCT( va_tl, va_tl  )
@@ -1334,4 +1330,7 @@
          zua_wop  (:,:,:) = ua  (:,:,:)
          zva_wop  (:,:,:) = va  (:,:,:)
+         CALL trj_rd_spl(file_xdx) 
+         zua_out  (:,:,:) = ua  (:,:,:)
+         zva_out  (:,:,:) = va  (:,:,:)
          !--------------------------------------------------------------------
          ! Compute the Linearization Error 
@@ -1474,3 +1473,4 @@
    !!======================================================================
 #endif
+#endif
 END MODULE dynhpg_tam
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynldf_bilap_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynldf_bilap_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynldf_bilap_tam.F90	(revision 2587)
@@ -471,16 +471,12 @@
             DO jj = jpjm1, 2, -1
                DO ji = fs_jpim1, fs_2, -1   ! vector opt.
-                  rotb_ad (ji  ,jj  ,jk) = rotb_ad (ji  ,jj  ,jk) &
-                                                  & + zlvad(ji,jj,jk) * fse3f(ji,jj  ,jk) / ( e1v(ji,jj) * fse3v(ji,jj,jk) )
-                  rotb_ad (ji-1,jj  ,jk) = rotb_ad (ji-1,jj  ,jk) &
-                                                  & - zlvad(ji,jj,jk) * fse3f(ji-1,jj,jk) / ( e1v(ji,jj) * fse3v(ji,jj,jk) )
+                  zufad   (ji  ,jj  ,jk) = zufad   (ji  ,jj  ,jk) + zlvad(ji  ,jj  ,jk) / ( e1v(ji,jj) * fse3v(ji,jj,jk) ) 
+                  zufad   (ji-1,jj  ,jk) = zufad   (ji-1,jj  ,jk) - zlvad(ji  ,jj  ,jk) / ( e1v(ji,jj) * fse3v(ji,jj,jk) )                   
                   hdivb_ad(ji  ,jj  ,jk) = hdivb_ad(ji  ,jj  ,jk) - zlvad(ji,jj,jk) / e2v(ji,jj)
                   hdivb_ad(ji  ,jj+1,jk) = hdivb_ad(ji  ,jj+1,jk) + zlvad(ji,jj,jk) / e2v(ji,jj)
                   zlvad(ji,jj,jk) = 0.0_wp
 
-                  rotb_ad (ji  ,jj  ,jk) = rotb_ad (ji  ,jj  ,jk) &
-                                                  & - zluad(ji,jj,jk) * fse3f(ji,jj  ,jk) / ( e2u(ji,jj) * fse3u(ji,jj,jk) )
-                  rotb_ad (ji  ,jj-1,jk) = rotb_ad (ji  ,jj-1,jk) &
-                                                  & + zluad(ji,jj,jk) * fse3f(ji,jj-1,jk) / ( e2u(ji,jj) * fse3u(ji,jj,jk) )
+                  zufad   (ji  ,jj  ,jk) = zufad   (ji  ,jj  ,jk) - zluad(ji  ,jj  ,jk) / ( e2u(ji,jj) * fse3u(ji,jj,jk) )
+                  zufad   (ji  ,jj-1,jk) = zufad   (ji  ,jj-1,jk) + zluad(ji  ,jj  ,jk) / ( e2u(ji,jj) * fse3u(ji,jj,jk) )
                   hdivb_ad(ji  ,jj  ,jk) = hdivb_ad(ji  ,jj  ,jk) - zluad(ji,jj,jk) / e1u(ji,jj)
                   hdivb_ad(ji+1,jj  ,jk) = hdivb_ad(ji+1,jj  ,jk) + zluad(ji,jj,jk) / e1u(ji,jj)
@@ -488,10 +484,5 @@
                END DO
             END DO
-!            DO jj = 1, jpj
-!               DO ji = 1, jpi
-!                  rotb_ad(ji,jj,jk) = rotb_ad(ji,jj,jk) + zufad(ji,jj,jk) * fse3f(ji,jj,jk)
-!                  zufad(ji,jj,jk) = 0.0_wp
-!               END DO
-!            END DO
+            rotb_ad(:,:,jk) = rotb_ad(:,:,jk) + zufad(:,:,jk) * fse3f(:,:,jk)
          ELSE                            ! z-coordinate - full step
             DO jj = jpjm1, 2, -1
@@ -501,5 +492,5 @@
                   hdivb_ad(ji  ,jj  ,jk) = hdivb_ad(ji  ,jj  ,jk) - zlvad(ji,jj,jk) / e2v(ji,jj)
                   hdivb_ad(ji  ,jj+1,jk) = hdivb_ad(ji  ,jj+1,jk) + zlvad(ji,jj,jk) / e2v(ji,jj)
-!                  zlvad(ji,jj,jk) = 0.0_wp
+                  zlvad(ji,jj,jk) = 0.0_wp
 
                   rotb_ad (ji  ,jj  ,jk) = rotb_ad (ji  ,jj  ,jk) - zluad(ji,jj,jk) / e2u(ji,jj)
@@ -507,5 +498,5 @@
                   hdivb_ad(ji  ,jj  ,jk) = hdivb_ad(ji  ,jj  ,jk) - zluad(ji,jj,jk) / e1u(ji,jj)
                   hdivb_ad(ji+1,jj  ,jk) = hdivb_ad(ji+1,jj  ,jk) + zluad(ji,jj,jk) / e1u(ji,jj)
-!                  zlvad(ji,jj,jk) = 0.0_wp
+                  zlvad(ji,jj,jk) = 0.0_wp
                END DO  
             END DO  
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynldf_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynldf_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynldf_tam.F90	(revision 2587)
@@ -287,5 +287,6 @@
          & ji,    &        ! dummy loop indices
          & jj,    &        
-         & jk     
+         & jk,    &
+         & jt     
       INTEGER, DIMENSION(jpi,jpj) :: &
          & iseed_2d        ! 2D seed for the random number generator
@@ -341,4 +342,9 @@
          & )
 
+      DO jt = 1, 2
+
+         IF (jt == 1) nldf=0  ! iso-level laplacian
+         IF (jt == 2) nldf=2  ! iso-level bilaplacian
+
       !==================================================================
       ! 1)      dx = ( ua_tl, va_tl, rotb_tl, hdivb_tl ) 
@@ -426,5 +432,6 @@
       va_tl   (:,:,:) = zva_tlin   (:,:,:)
 
-      CALL dyn_ldf_tan ( nit000 )
+         IF (nldf == 0 )  CALL dyn_ldf_lap_tan(   nit000 )
+         IF (nldf == 2 )  CALL dyn_ldf_bilap_tan( nit000 )
 
       zua_tlout(:,:,:) = ua_tl(:,:,:)
@@ -463,5 +470,6 @@
       va_ad(:,:,:) = zva_adin(:,:,:)
 
-      CALL dyn_ldf_adj ( nit000 )
+         IF (nldf == 0 )  CALL dyn_ldf_lap_adj(   nit000 )
+         IF (nldf == 2 )  CALL dyn_ldf_bilap_adj( nit000 )
 
       zua_adout   (:,:,:) = ua_ad   (:,:,:)
@@ -482,6 +490,9 @@
       ! Compare the scalar products
       ! 14 char:'12345678901234'
-      cl_name = 'dyn_ldf_adj   '
+         IF (nldf == 0 )  cl_name = 'dynldf_adj lap'
+         IF (nldf == 2 )  cl_name = 'dynldf_adj blp'
       CALL prntst_adj( cl_name, kumadt, zsp1, zsp2 )
+
+      END DO
 
       DEALLOCATE( &
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynspg_flt_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynspg_flt_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynspg_flt_tam.F90	(revision 2587)
@@ -178,4 +178,5 @@
       & stdemp,              &
       & stdssh,              &
+      & stdgc,               &
       & prntst_adj,          &
       & prntst_tlm           
@@ -187,7 +188,8 @@
    PUBLIC dyn_spg_flt_tan,     & ! routine called by step_tan.F90
       &   dyn_spg_flt_adj,     & ! routine called by step_adj.F90
-      &   dyn_spg_flt_adj_tst, & ! routine called by the tst.F90
-      &   dyn_spg_flt_tlm_tst
-
+      &   dyn_spg_flt_adj_tst    ! routine called by the tst.F90
+#if defined key_tst_tlm
+   PUBLIC dyn_spg_flt_tlm_tst
+#endif
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -1395,5 +1397,5 @@
    END SUBROUTINE dyn_spg_flt_adj_tst
 
-
+#if defined key_tst_tlm
    SUBROUTINE dyn_spg_flt_tlm_tst( kumadt )
       !!-----------------------------------------------------------------------
@@ -1430,4 +1432,5 @@
       USE tamtrj              ! writing out state trajectory
       USE par_tlm,    ONLY: &
+        & tlm_bch,          &
         & cur_loop,         &
         & h_ratio
@@ -1438,7 +1441,10 @@
       USE oce       , ONLY: & ! ocean dynamics and tracers variables
         & ua, va, ub, vb,   &
+        & un, vn, &
         & sshb, sshn, wn
       USE sbc_oce   , ONLY: &
         & emp
+      USE sol_oce           , ONLY: & ! ocean dynamics and tracers variables
+        & gcb, gcx
       USE tamctl,         ONLY: & ! Control parameters
        & numtan, numtan_sc
@@ -1469,4 +1475,12 @@
          & zsshn_wop,  &
          & z2r           ! 2D field
+      REAL(KIND=wp), DIMENSION(:,:), ALLOCATABLE :: &
+         & zgcb_tlin ,     & ! Tangent input
+         & zgcx_tlin ,     & ! Tangent input
+         & zgcb_out  ,     & ! Direct output
+         & zgcx_out  ,     & ! Direct output
+         & zgcb_wop  ,     & ! Direct output without perturbation
+         & zgcx_wop  ,     & ! Direct output without perturbation
+         & zr             ! 3D random field
       REAL(KIND=wp) :: &
          & zsp1, zsp1_1, zsp1_2, zsp1_3, zsp1_4,  &   ! 
@@ -1475,4 +1489,6 @@
          & zzsp, zzsp_1, zzsp_2, zzsp_3, zzsp_4,  &
          & gamma,                                 &
+         & zsp_5,zsp1_5, zsp2_5, zsp3_5, zsp4_5,  &
+         & zzsp_5, zsp_6, &
          & zgsp1, zgsp2, zgsp3, zgsp4, zgsp5,     &
          & zgsp6, zgsp7
@@ -1485,5 +1501,5 @@
          & jk
       CHARACTER(LEN=14)   :: cl_name
-      CHARACTER (LEN=128) :: file_out, file_wop
+      CHARACTER (LEN=128) :: file_out, file_wop, file_xdx
       CHARACTER (LEN=90)  ::  FMT
       REAL(KIND=wp), DIMENSION(100):: &
@@ -1492,4 +1508,12 @@
          & zscsshb, zscsshn,    &
          & zscerrsshb, zscerrsshn
+      REAL(KIND=wp), DIMENSION(jpi,jpj) :: &
+         & zerrgcb, zerrgcx
+      REAL(KIND=wp), DIMENSION(100):: &
+         & zscgcb,zscgcx,             &
+         & zscerrgcb, zscerrgcx
+      INTEGER, DIMENSION(100):: &
+         & iiposgcb, ijposgcb,          &
+         & iiposgcx, ijposgcx
       INTEGER, DIMENSION(100):: &
          & iipossshb, iipossshn, iiposua, iiposva,   &
@@ -1530,4 +1554,13 @@
          & z2r(jpi,jpj)         &
          & )
+      ALLOCATE( &
+         & zgcb_tlin( jpi,jpj),     &
+         & zgcx_tlin( jpi,jpj),     &
+         & zgcb_out ( jpi,jpj),     &
+         & zgcx_out ( jpi,jpj),     &
+         & zgcb_wop ( jpi,jpj),     &
+         & zgcx_wop ( jpi,jpj),     &
+         & zr(        jpi,jpj)      &
+         & )
       !--------------------------------------------------------------------
       ! Reset variables
@@ -1562,10 +1595,19 @@
       zerrsshb(:,:)    = 0.0_wp
       zerrsshn(:,:)    = 0.0_wp
+
+      zgcb_tlin( :,:) = 0.0_wp
+      zgcx_tlin( :,:) = 0.0_wp
+      zgcb_out ( :,:) = 0.0_wp
+      zgcx_out ( :,:) = 0.0_wp
+      zgcb_wop ( :,:) = 0.0_wp
+      zgcx_wop ( :,:) = 0.0_wp
+      zr(        :,:) = 0.0_wp
       !--------------------------------------------------------------------
       ! Output filename Xn=F(X0)
       !--------------------------------------------------------------------
-      file_wop='trj_wop_dynspg'
       CALL tlm_namrd
       gamma = h_ratio
+      file_wop='trj_wop_dynspg'
+      file_xdx='trj_xdx_dynspg'
       !--------------------------------------------------------------------
       ! Initialize the tangent input with random noise: dx
@@ -1630,4 +1672,16 @@
             END DO
          END DO
+         CALL grid_rd_sd( 596035, zr,  c_solver_pt, 0.0_wp, stdgc)    
+         DO jj = nldj, nlej
+            DO ji = nldi, nlei
+               zgcb_tlin(ji,jj) = zr(ji,jj)
+            END DO
+         END DO     
+         CALL grid_rd_sd( 264792, zr,  c_solver_pt, 0.0_wp, stdgc)    
+         DO jj = nldj, nlej
+            DO ji = nldi, nlei
+               zgcx_tlin(ji,jj) = zr(ji,jj)
+            END DO
+         END DO
       ENDIF    
 
@@ -1636,10 +1690,14 @@
       !-------------------------------------------------------------------
       CALL istate_p  
-
       ! *** initialize the reference trajectory
       ! ------------
       CALL  trj_rea( nit000-1, 1 )
       CALL  trj_rea( nit000, 1 )
-
+      ua(:,:,:)=un(:,:,:)
+      va(:,:,:)=vn(:,:,:)
+      ub(:,:,:)=un(:,:,:)
+      vb(:,:,:)=vn(:,:,:)
+      gcx  (:,:) =  ua(:,:,1) / 10.0_wp
+      gcb  (:,:) =  ua(:,:,3) / 10.0_wp
 
       IF (( cur_loop .NE. 0) .OR. ( gamma .NE. 0.0_wp) )THEN
@@ -1667,4 +1725,10 @@
          zsshn_tlin(:,:) = gamma * zsshn_tlin(:,:)
          sshn(:,:)       = sshn(:,:) + zsshn_tlin(:,:)
+
+         zgcb_tlin(:,:) = gamma * zgcb_tlin(:,:)
+         gcb(:,:)       = gcb(:,:) + zgcb_tlin(:,:)
+
+         zgcx_tlin(:,:) = gamma * zgcx_tlin(:,:)
+         gcx(:,:)       = gcx(:,:) + zgcx_tlin(:,:)
       ENDIF
 
@@ -1672,17 +1736,14 @@
       !  Compute the direct model F(X0,t=n) = Xn
       !--------------------------------------------------------------------
-      CALL dyn_spg_flt(nit000, indic)
-      IF ( cur_loop .EQ. 0) CALL trj_wri_spl(file_wop)
+      IF ( tlm_bch /= 2 ) CALL dyn_spg_flt(nit000, indic)
+      IF ( tlm_bch == 0 ) CALL trj_wri_spl(file_wop)
+      IF ( tlm_bch == 1 ) CALL trj_wri_spl(file_xdx)
       !--------------------------------------------------------------------
       !  Compute the Tangent 
       !--------------------------------------------------------------------
-      IF ( cur_loop .NE. 0) THEN
-         !--------------------------------------------------------------------
-         !  Storing data
-         !--------------------------------------------------------------------  
-         zua_out  (:,:,:) = ua   (:,:,:)
-         zva_out  (:,:,:) = va   (:,:,:)
-         zsshb_out(:,:  ) = sshb (:,:  )
-         zsshn_out(:,:  ) = sshn (:,:  )
+      IF ( tlm_bch == 2 ) THEN
+         gcx_tl (:,:) = 0.0_wp
+         gcxb_tl(:,:) = 0.0_wp
+         gcb_tl (:,:) = 0.0_wp
          !--------------------------------------------------------------------
          ! Initialize the tangent variables 
@@ -1698,4 +1759,6 @@
          sshb_tl(:,:  ) = zsshb_tlin(:,:  )
          sshn_tl(:,:  ) = zsshn_tlin(:,:  )
+         gcb_tl  (:,:) = zgcb_tlin  (:,:)
+         gcx_tl  (:,:) = zgcx_tlin  (:,:)
 
          CALL dyn_spg_flt_tan(nit000, indic)
@@ -1708,5 +1771,8 @@
          zsp2_3    = DOT_PRODUCT( sshb_tl, sshb_tl  )
          zsp2_4    = DOT_PRODUCT( sshn_tl, sshn_tl  )
-         zsp2      = zsp2_1 + zsp2_2 + zsp2_3 + zsp2_4
+         zsp_5    = DOT_PRODUCT( gcx_tl, gcx_tl  )
+         zsp_6    = DOT_PRODUCT( gcxb_tl, gcxb_tl  )
+
+         zsp2      = zsp2_1 + zsp2_2 + zsp2_3 + zsp2_4 + zsp_5 + zsp_6
          !--------------------------------------------------------------------
          !  Storing data
@@ -1717,4 +1783,11 @@
          zsshb_wop(:,:) = sshb(:,:)
          zsshn_wop(:,:) = sshn(:,:)
+         zgcx_wop  (:,:) = gcx  (:,:)
+         CALL trj_rd_spl(file_xdx) 
+         zua_out  (:,:,:) = ua  (:,:,:)
+         zva_out  (:,:,:) = va  (:,:,:)
+         zsshb_out(:,:) = sshb(:,:)
+         zsshn_out(:,:) = sshn(:,:)
+         zgcx_out  (:,:) = gcx  (:,:)
          !--------------------------------------------------------------------
          ! Compute the Linearization Error 
@@ -1809,14 +1882,34 @@
             END DO
          END DO
+         ii=0
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               zgcx_out   (ji,jj) = zgcx_out    (ji,jj) - zgcx_wop  (ji,jj)
+               zgcx_wop   (ji,jj) = zgcx_out    (ji,jj) - gcx_tl    (ji,jj)
+               IF (  gcx_tl(ji,jj) .NE. 0.0_wp ) zerrgcx(ji,jj) = zgcx_out(ji,jj)/gcx_tl(ji,jj)
+               IF( (MOD(ji, isamp) .EQ. 0) .AND. &
+               &   (MOD(jj, jsamp) .EQ. 0) ) THEN
+                   ii = ii+1
+                   iiposgcx(ii) = ji
+                   ijposgcx(ii) = jj
+                   IF ( INT(tmask(ji,jj,1)) .NE. 0)  THEN
+                      zscgcx (ii)    =  zgcx_wop(ji,jj)
+                      zscerrgcx (ii) =  ( zerrgcx(ji,jj) - 1.0_wp ) / gamma
+                   ENDIF
+               ENDIF
+            END DO
+         END DO
          zsp1_1    = DOT_PRODUCT( zua_out,   zua_out    )
          zsp1_2    = DOT_PRODUCT( zva_out,   zva_out    )
          zsp1_3    = DOT_PRODUCT( zsshb_out, zsshb_out  )
          zsp1_4    = DOT_PRODUCT( zsshn_out, zsshn_out  )
-         zsp1      = zsp1_1 + zsp1_2 + zsp1_3 + zsp1_4
+         zsp1_5   = DOT_PRODUCT( zgcx_out, zgcx_out  )
+         zsp1      = zsp1_1 + zsp1_2 + zsp1_3 + zsp1_4 + zsp1_5
          zsp3_1    = DOT_PRODUCT( zua_wop,   zua_wop    )
          zsp3_2    = DOT_PRODUCT( zva_wop,   zva_wop    )
          zsp3_3    = DOT_PRODUCT( zsshb_wop, zsshb_wop  )
          zsp3_4    = DOT_PRODUCT( zsshn_wop, zsshn_wop  )
-         zsp3      = zsp3_1 + zsp3_2 + zsp3_3 + zsp3_4
+         zsp3_5   = DOT_PRODUCT( zgcx_wop, zgcx_wop  )
+         zsp3      = zsp3_1 + zsp3_2 + zsp3_3 + zsp3_4 + zsp3_5
 
          !--------------------------------------------------------------------
@@ -1830,4 +1923,5 @@
          zzsp_3   = SQRT(zsp3_3)
          zzsp_4   = SQRT(zsp3_4)
+         zzsp_5   = SQRT(zsp3_5)
          zgsp5    = zzsp
          CALL prntst_tlm( cl_name, kumadt, zzsp, h_ratio )
@@ -1840,4 +1934,5 @@
          zzsp_3   = SQRT(zsp2_3)
          zzsp_4   = SQRT(zsp2_4)
+         zzsp_5   = SQRT(zsp2_5)
          zgsp4    = zzsp
          cl_name = 'dynspg_tam:Ln2'
@@ -1851,4 +1946,5 @@
          zzsp_3   = SQRT(zsp1_3)
          zzsp_4   = SQRT(zsp1_4)
+         zzsp_5   = SQRT(zsp1_5)
          cl_name  = 'dynspg:Mhdx-Mx'
          CALL prntst_tlm( cl_name, kumadt, zzsp, h_ratio )
@@ -1918,5 +2014,5 @@
    END SUBROUTINE dyn_spg_flt_tlm_tst
 #endif
-
+#endif
 #endif
 END MODULE dynspg_flt_tam
Index: branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynspg_tam.F90
===================================================================
--- branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynspg_tam.F90	(revision 1947)
+++ branches/TAM_V3_0/NEMOTAM/OPATAM_SRC/DYN/dynspg_tam.F90	(revision 2587)
@@ -58,6 +58,8 @@
    PUBLIC dyn_spg_tan,     &   ! routine called by steptan module
       &   dyn_spg_adj,     &   ! routine called by stepadj module
-      &   dyn_spg_adj_tst, &   ! routine controlling adjoint tests
-      &   dyn_spg_tlm_tst 
+      &   dyn_spg_adj_tst      ! routine controlling adjoint tests
+#if defined key_tst_tlm
+   PUBLIC dyn_spg_tlm_tst
+#endif 
 
    !! * module variables
@@ -262,5 +264,5 @@
 
    END SUBROUTINE dyn_spg_ctl_tam
-
+#if defined key_tst_tlm
    SUBROUTINE dyn_spg_tlm_tst( kumadt )
       !!-----------------------------------------------------------------------
@@ -310,3 +312,4 @@
   !!======================================================================
 #endif
+#endif
 END MODULE dynspg_tam
